diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/block-ack-manager.h ns-3.44/src/wifi/model/block-ack-manager.h
--- ns-3.43/src/wifi/model/block-ack-manager.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/block-ack-manager.h	2025-03-09 16:55:49.783372600 -0700
@@ -10,6 +10,7 @@
 #define BLOCK_ACK_MANAGER_H
 
 #include "block-ack-type.h"
+#include "gcr-manager.h"
 #include "originator-block-ack-agreement.h"
 #include "recipient-block-ack-agreement.h"
 #include "wifi-mac-header.h"
@@ -34,8 +35,8 @@
 class MacRxMiddle;
 
 /**
- * \brief Manages all block ack agreements for an originator station.
- * \ingroup wifi
+ * @brief Manages all block ack agreements for an originator station.
+ * @ingroup wifi
  */
 class BlockAckManager : public Object
 {
@@ -52,8 +53,8 @@
 
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -72,29 +73,36 @@
         std::optional<std::reference_wrapper<const RecipientBlockAckAgreement>>;
 
     /**
-     * \param recipient MAC address of the recipient
-     * \param tid Traffic ID
+     * @param recipient MAC address of the recipient
+     * @param tid Traffic ID
+     * @param gcrGroupAddr the GCR Group Address (only if it is a GCR Block Ack agreement)
      *
-     * \return a const reference to the block ack agreement with the given recipient, if it exists
+     * @return a const reference to the block ack agreement with the given recipient, if it exists
      *
      * Check if we are the originator of an existing block ack agreement with the given recipient.
      */
-    OriginatorAgreementOptConstRef GetAgreementAsOriginator(const Mac48Address& recipient,
-                                                            uint8_t tid) const;
+    OriginatorAgreementOptConstRef GetAgreementAsOriginator(
+        const Mac48Address& recipient,
+        uint8_t tid,
+        std::optional<Mac48Address> gcrGroupAddr = std::nullopt) const;
+
     /**
-     * \param originator MAC address of the originator
-     * \param tid Traffic ID
+     * @param originator MAC address of the originator
+     * @param tid Traffic ID
+     * @param gcrGroupAddr the GCR Group Address (only if it is a GCR Block Ack agreement)
      *
-     * \return a const reference to the block ack agreement with the given originator, if it exists
+     * @return a const reference to the block ack agreement with the given originator, if it exists
      *
      * Check if we are the recipient of an existing block ack agreement with the given originator.
      */
-    RecipientAgreementOptConstRef GetAgreementAsRecipient(const Mac48Address& originator,
-                                                          uint8_t tid) const;
+    RecipientAgreementOptConstRef GetAgreementAsRecipient(
+        const Mac48Address& originator,
+        uint8_t tid,
+        std::optional<Mac48Address> gcrGroupAddr = std::nullopt) const;
 
     /**
-     * \param reqHdr Relative Add block ack request (action frame).
-     * \param recipient Address of peer station involved in block ack mechanism.
+     * @param reqHdr Relative Add block ack request (action frame).
+     * @param recipient Address of peer station involved in block ack mechanism.
      *
      * Creates a new originator block ack agreement in pending state. When a ADDBA response
      * with a successful status code is received, the relative agreement becomes established.
@@ -102,17 +110,20 @@
     void CreateOriginatorAgreement(const MgtAddBaRequestHeader& reqHdr,
                                    const Mac48Address& recipient);
     /**
-     * \param recipient Address of peer station involved in block ack mechanism.
-     * \param tid traffic ID of transmitted packet.
+     * @param recipient Address of peer station involved in block ack mechanism.
+     * @param tid traffic ID of transmitted packet.
+     * @param gcrGroupAddr the GCR Group Address (only if it a GCR Block Ack agreement)
      *
      * Invoked when a recipient reject a block ack agreement or when a DELBA frame
      * is Received/Transmitted.
      */
-    void DestroyOriginatorAgreement(const Mac48Address& recipient, uint8_t tid);
-    /**
-     * \param respHdr Relative Add block ack response (action frame).
-     * \param recipient Address of peer station involved in block ack mechanism.
-     * \param startingSeq the updated starting sequence number
+    void DestroyOriginatorAgreement(const Mac48Address& recipient,
+                                    uint8_t tid,
+                                    std::optional<Mac48Address> gcrGroupAddr);
+    /**
+     * @param respHdr Relative Add block ack response (action frame).
+     * @param recipient Address of peer station involved in block ack mechanism.
+     * @param startingSeq the updated starting sequence number
      *
      * Invoked upon receipt of a ADDBA response frame from <i>recipient</i>.
      */
@@ -121,13 +132,13 @@
                                    uint16_t startingSeq);
 
     /**
-     * \param respHdr Add block ack response from originator (action
+     * @param respHdr Add block ack response from originator (action
      *        frame).
-     * \param originator Address of peer station involved in block ack
+     * @param originator Address of peer station involved in block ack
      *        mechanism.
-     * \param startingSeq Sequence number of the first MPDU of all
+     * @param startingSeq Sequence number of the first MPDU of all
      *        packets for which block ack was negotiated.
-     * \param rxMiddle the MAC RX Middle on this station
+     * @param rxMiddle the MAC RX Middle on this station
      *
      * This function is typically invoked only by ns3::WifiMac
      * when the STA (which may be non-AP in ESS, or in an IBSS) has
@@ -143,26 +154,39 @@
     /**
      * Destroy a recipient Block Ack agreement.
      *
-     * \param originator the originator MAC address
-     * \param tid the TID associated with the Block Ack agreement
+     * @param originator the originator MAC address
+     * @param tid the TID associated with the Block Ack agreement
+     * @param gcrGroupAddr the GCR Group Address (only if it a GCR Block Ack agreement)
      */
-    void DestroyRecipientAgreement(const Mac48Address& originator, uint8_t tid);
+    void DestroyRecipientAgreement(const Mac48Address& originator,
+                                   uint8_t tid,
+                                   std::optional<Mac48Address> gcrGroupAddr);
 
     /**
-     * \param mpdu MPDU to store.
+     * @param mpdu MPDU to store.
      *
      * Stores <i>mpdu</i> for a possible future retransmission. Retransmission occurs
-     * if the packet, in a BlockAck frame, is indicated by recipient as not received.
+     * if the packet, in a Block Ack frame, is indicated by recipient as not received.
      */
     void StorePacket(Ptr<WifiMpdu> mpdu);
+
+    /**
+     * @param mpdu groupcast MPDU to store.
+     * @param members intended recipients for the groupcast MPDU.
+     *
+     * Stores <i>mpdu</i> for a possible future retransmission. Retransmission occurs
+     * if the packet, in a GCR Block Ack frame, is indicated by recipient as not received.
+     */
+    void StoreGcrPacket(Ptr<WifiMpdu> mpdu, const GcrManager::GcrMembers& members);
+
     /**
      * Invoked upon receipt of an Ack frame on the given link after the transmission of a
      * QoS data frame sent under an established block ack agreement. Remove the acknowledged
      * frame from the outstanding packets and update the starting sequence number of the
      * transmit window, if needed.
      *
-     * \param linkId the ID of the given link
-     * \param mpdu The acknowledged MPDU.
+     * @param linkId the ID of the given link
+     * @param mpdu The acknowledged MPDU.
      */
     void NotifyGotAck(uint8_t linkId, Ptr<const WifiMpdu> mpdu);
     /**
@@ -171,22 +195,22 @@
      * Remove the acknowledged frame from the outstanding packets and insert it in the
      * retransmission queue.
      *
-     * \param linkId the ID of the given link
-     * \param mpdu The unacknowledged MPDU.
+     * @param linkId the ID of the given link
+     * @param mpdu The unacknowledged MPDU.
      */
     void NotifyMissedAck(uint8_t linkId, Ptr<WifiMpdu> mpdu);
     /**
-     * \param linkId the ID of the given link
-     * \param blockAck The received BlockAck frame.
-     * \param recipient Sender of BlockAck frame.
-     * \param tids the set of TIDs the acknowledged MPDUs belong to
-     * \param index the index of the Per AID TID Info subfield, in case of Multi-STA
+     * @param linkId the ID of the given link
+     * @param blockAck The received BlockAck frame.
+     * @param recipient Sender of BlockAck frame.
+     * @param tids the set of TIDs the acknowledged MPDUs belong to
+     * @param index the index of the Per AID TID Info subfield, in case of Multi-STA
      *              Block Ack, or 0, otherwise
-     * \return a pair of values indicating the number of successfully received MPDUs
+     * @return a pair of values indicating the number of successfully received MPDUs
      *         and the number of failed MPDUs
      *
-     * Invoked upon receipt of a BlockAck frame on the given link. Typically, this function
-     * is called by ns3::QosTxop object. Performs a check on which MPDUs, previously sent
+     * Invoked upon receipt of a Block Ack frame on the given link. Typically, this function
+     * is called by the frame exchange manager. Performs a check on which MPDUs, previously sent
      * with Ack Policy set to Block Ack, were correctly received by the recipient.
      * An acknowledged MPDU is removed from the buffer, retransmitted otherwise.
      * Note that <i>tids</i> is only used if <i>blockAck</i> is a Multi-STA Block Ack
@@ -197,10 +221,32 @@
                                                     const Mac48Address& recipient,
                                                     const std::set<uint8_t>& tids,
                                                     size_t index = 0);
+
     /**
-     * \param linkId the ID of the given link
-     * \param recipient Sender of the expected BlockAck frame.
-     * \param tid Traffic ID.
+     * @param linkId the ID of the given link
+     * @param blockAck The received BlockAck frame.
+     * @param recipient Sender of BlockAck frame.
+     * @param members the list of member STAs for that GCR group
+     * @return a pair of values indicating the number of successfully received MPDUs
+     *         and the number of failed MPDUs if GCR Block Ack frames for all member STAs
+     *         have been received.
+     *
+     * Invoked upon receipt of a GCR Block Ack frame on the given link. Typically, this function
+     * is called by the frame exchange manager. Stores the received Block Ack response for each
+     * GCR member STA. Once all responses have been received, it performs a check on which MPDUs,
+     * previously sent with Ack Policy set to Block Ack, were correctly received by the recipient.
+     * An acknowledged MPDU is removed from the buffer, retransmitted otherwise.
+     */
+    std::optional<std::pair<uint16_t, uint16_t>> NotifyGotGcrBlockAck(
+        uint8_t linkId,
+        const CtrlBAckResponseHeader& blockAck,
+        const Mac48Address& recipient,
+        const GcrManager::GcrMembers& members);
+
+    /**
+     * @param linkId the ID of the given link
+     * @param recipient Sender of the expected BlockAck frame.
+     * @param tid Traffic ID.
      *
      * Invoked upon missed reception of a block ack frame on the given link. Typically, this
      * function is called by ns3::QosTxop object. Performs a check on which MPDUs, previously
@@ -208,70 +254,71 @@
      */
     void NotifyMissedBlockAck(uint8_t linkId, const Mac48Address& recipient, uint8_t tid);
     /**
-     * \param originator MAC address of the sender of the Block Ack Request
-     * \param tid Traffic ID
-     * \param startingSeq the starting sequence number in the Block Ack Request
+     * @param originator MAC address of the sender of the Block Ack Request
+     * @param tid Traffic ID
+     * @param startingSeq the starting sequence number in the Block Ack Request
+     * @param gcrGroupAddr the GCR Group Address (only if it is a GCR Block Ack Request frame)
      *
      * Perform required actions upon receiving a Block Ack Request frame.
      */
     void NotifyGotBlockAckRequest(const Mac48Address& originator,
                                   uint8_t tid,
-                                  uint16_t startingSeq);
+                                  uint16_t startingSeq,
+                                  std::optional<Mac48Address> gcrGroupAddr = std::nullopt);
+
     /**
-     * \param mpdu the received MPDU
+     * @param mpdu the received MPDU
      *
      * Perform required actions upon receiving an MPDU.
      */
     void NotifyGotMpdu(Ptr<const WifiMpdu> mpdu);
     /**
-     * \param recipient Address of peer station involved in block ack mechanism.
-     * \param tid Traffic ID.
+     * @param recipient Address of peer station involved in block ack mechanism.
+     * @param tid Traffic ID.
      *
-     * \return the number of packets buffered for a specified agreement
+     * @return the number of packets buffered for a specified agreement
      *
      * Returns the number of packets buffered for a specified agreement. This methods doesn't return
      * the number of buffered MPDUs but the number of buffered MSDUs.
      */
     uint32_t GetNBufferedPackets(const Mac48Address& recipient, uint8_t tid) const;
     /**
-     * \param recipient Address of peer station involved in block ack mechanism.
-     * \param tid Traffic ID of transmitted packet.
-     * \param startingSeq starting sequence field
-     *
-     * Puts corresponding originator agreement in established state and updates number of packets
-     * and starting sequence field. Invoked typically after a block ack refresh.
-     */
-    void NotifyOriginatorAgreementEstablished(const Mac48Address& recipient,
-                                              uint8_t tid,
-                                              uint16_t startingSeq);
-    /**
-     * \param recipient Address of peer station involved in block ack mechanism.
-     * \param tid Traffic ID of transmitted packet.
+     * @param recipient Address of peer station involved in block ack mechanism.
+     * @param tid Traffic ID of transmitted packet.
+     * @param gcrGroupAddr the GCR Group Address (only if it a GCR Block Ack agreement)
      *
      * Marks an originator agreement as rejected. This happens if <i>recipient</i> station reject
      * block ack setup by an ADDBA Response frame with a failure status code. For now we assume
      * that every QoS station accepts a block ack setup.
      */
-    void NotifyOriginatorAgreementRejected(const Mac48Address& recipient, uint8_t tid);
-    /**
-     * \param recipient Address of peer station involved in block ack mechanism.
-     * \param tid Traffic ID of transmitted packet.
+    void NotifyOriginatorAgreementRejected(const Mac48Address& recipient,
+                                           uint8_t tid,
+                                           std::optional<Mac48Address> gcrGroupAddr);
+    /**
+     * @param recipient Address of peer station involved in block ack mechanism.
+     * @param tid Traffic ID of transmitted packet.
+     * @param gcrGroupAddr the GCR Group Address (only if it a GCR Block Ack agreement)
      *
      * Marks an originator agreement after not receiving response to ADDBA request. During this
      * state any packets in queue will be transmitted using normal MPDU. This also unblocks
      * recipient address.
      */
-    void NotifyOriginatorAgreementNoReply(const Mac48Address& recipient, uint8_t tid);
-    /**
-     * \param recipient Address of peer station involved in block ack mechanism.
-     * \param tid Traffic ID of transmitted packet.
+    void NotifyOriginatorAgreementNoReply(const Mac48Address& recipient,
+                                          uint8_t tid,
+                                          std::optional<Mac48Address> gcrGroupAddr);
+    /**
+     * @param recipient Address of peer station involved in block ack mechanism.
+     * @param tid Traffic ID of transmitted packet.
+     * @param gcrGroupAddr the GCR Group Address (only if it a GCR Block Ack agreement)
      *
      * Set Originator BA agreement to a transitory state to reset it after not receiving response
      * to ADDBA request.
      */
-    void NotifyOriginatorAgreementReset(const Mac48Address& recipient, uint8_t tid);
+    void NotifyOriginatorAgreementReset(const Mac48Address& recipient,
+                                        uint8_t tid,
+                                        std::optional<Mac48Address> gcrGroupAddr);
     /**
-     * \param nPackets Minimum number of packets for use of block ack.
+     * @param nPackets Minimum number of packets for use of block ack.
      *
      * Upon receipt of a BlockAck frame, if total number of packets (packets in WifiMacQueue
      * and buffered packets) is greater of <i>nPackets</i>, they are transmitted using block ack
@@ -280,23 +327,24 @@
     void SetBlockAckThreshold(uint8_t nPackets);
 
     /**
-     * \param queue The WifiMacQueue object.
+     * @param queue The WifiMacQueue object.
      */
     void SetQueue(const Ptr<WifiMacQueue> queue);
 
     /**
      * Set block ack inactivity callback
-     * \param callback the block ack inactivity callback function
+     * @param callback the block ack inactivity callback function
      */
-    void SetBlockAckInactivityCallback(Callback<void, Mac48Address, uint8_t, bool> callback);
+    void SetBlockAckInactivityCallback(
+        Callback<void, Mac48Address, uint8_t, bool, std::optional<Mac48Address>> callback);
     /**
      * Set block destination callback
-     * \param callback the block destination callback
+     * @param callback the block destination callback
      */
     void SetBlockDestinationCallback(Callback<void, Mac48Address, uint8_t> callback);
     /**
      * Set unblock destination callback
-     * \param callback the unblock destination callback
+     * @param callback the unblock destination callback
      */
     void SetUnblockDestinationCallback(Callback<void, Mac48Address, uint8_t> callback);
 
@@ -305,28 +353,44 @@
      * given recipient for the given TID and there is at least an outstanding MPDU
      * for such agreement whose lifetime is not expired.
      *
-     * \param tid Traffic ID
-     * \param recipient MAC address of the recipient
+     * @param tid Traffic ID
+     * @param recipient MAC address of the recipient
      *
-     * \returns true if BAR retransmission needed
+     * @returns true if BAR retransmission needed
      */
     bool NeedBarRetransmission(uint8_t tid, const Mac48Address& recipient);
+
+    /**
+     * This function returns true if a GCR block ack agreement is established with the given
+     * recipient, for the given TID, for the given GCR group address and there is at least an
+     * outstanding MPDU for such agreement whose lifetime is not expired.
+     *
+     * @param gcrGroupAddress the GCR group address
+     * @param tid Traffic ID
+     * @param recipient MAC address of the recipient
+     *
+     * @returns true if BAR retransmission needed
+     */
+    bool NeedGcrBarRetransmission(const Mac48Address& gcrGroupAddress,
+                                  const Mac48Address& recipient,
+                                  uint8_t tid) const;
+
     /**
      * This function returns the buffer size negotiated with the recipient.
      *
-     * \param tid Traffic ID
-     * \param recipient MAC address of the recipient
+     * @param tid Traffic ID
+     * @param recipient MAC address of the recipient
      *
-     * \returns the buffer size negotiated with the recipient
+     * @returns the buffer size negotiated with the recipient
      */
     uint16_t GetRecipientBufferSize(const Mac48Address& recipient, uint8_t tid) const;
     /**
      * This function returns the starting sequence number of the transmit window.
      *
-     * \param tid Traffic ID
-     * \param recipient MAC address of the recipient
+     * @param tid Traffic ID
+     * @param recipient MAC address of the recipient
      *
-     * \returns the starting sequence number of the transmit window (WinStartO)
+     * @returns the starting sequence number of the transmit window (WinStartO)
      */
     uint16_t GetOriginatorStartingSequence(const Mac48Address& recipient, uint8_t tid) const;
 
@@ -344,27 +408,27 @@
     typedef Callback<void, Ptr<const WifiMpdu>> DroppedOldMpdu;
 
     /**
-     * \param callback the callback to invoke when a
+     * @param callback the callback to invoke when a
      * packet transmission was completed successfully.
      */
     void SetTxOkCallback(TxOk callback);
     /**
-     * \param callback the callback to invoke when a
+     * @param callback the callback to invoke when a
      * packet transmission was completed unsuccessfuly.
      */
     void SetTxFailedCallback(TxFailed callback);
     /**
-     * \param callback the callback to invoke when an old MPDU is dropped
+     * @param callback the callback to invoke when an old MPDU is dropped
      */
     void SetDroppedOldMpduCallback(DroppedOldMpdu callback);
 
     /**
      * TracedCallback signature for state changes.
      *
-     * \param [in] now Time when the \pname{state} changed.
-     * \param [in] recipient MAC address of the recipient.
-     * \param [in] tid the TID.
-     * \param [in] state The state.
+     * @param [in] now Time when the \pname{state} changed.
+     * @param [in] recipient MAC address of the recipient.
+     * @param [in] tid the TID.
+     * @param [in] state The state.
      */
     typedef void (*AgreementStateTracedCallback)(Time now,
                                                  const Mac48Address& recipient,
@@ -372,7 +436,7 @@
                                                  OriginatorBlockAckAgreement::State state);
 
     /**
-     * \param mpdu the discarded frame
+     * @param mpdu the discarded frame
      *
      * Notify the block ack manager that an MPDU has been discarded, e.g., because
      * the MSDU lifetime expired. If there is an established block ack agreement,
@@ -384,18 +448,23 @@
     void NotifyDiscardedMpdu(Ptr<const WifiMpdu> mpdu);
 
     /**
-     * \param recipient the recipient
-     * \param tid the TID
-     * \return the BlockAckRequest header for the established BA agreement
+     * @param recipient the recipient
+     * @param tid the TID
+     * @param gcrGroupAddr the GCR Group Address (only if the Block Ack Request is being used for
+     * the GCR service)
+     * @return the BlockAckRequest header for the established BA agreement
      *
      * Get the BlockAckRequest header for the established BA agreement
      * (<i>recipient</i>,<i>tid</i>).
      */
-    CtrlBAckRequestHeader GetBlockAckReqHeader(const Mac48Address& recipient, uint8_t tid) const;
+    CtrlBAckRequestHeader GetBlockAckReqHeader(
+        const Mac48Address& recipient,
+        uint8_t tid,
+        std::optional<Mac48Address> gcrGroupAddr = std::nullopt) const;
 
     /**
-     * \param reqHdr the BlockAckRequest header
-     * \param hdr the 802.11 MAC header
+     * @param reqHdr the BlockAckRequest header
+     * @param hdr the 802.11 MAC header
      *
      * Enqueue the given BlockAckRequest into the queue storing the next BAR
      * frames to transmit. If a BAR for the same recipient and TID is already present
@@ -408,7 +477,7 @@
     using AgreementKey = std::pair<Mac48Address, uint8_t>;
 
     /**
-     * \return the list of BA agreements (identified by the recipient and TID pair) for which a BAR
+     * @return the list of BA agreements (identified by the recipient and TID pair) for which a BAR
      * shall only be sent if there are queued data frames belonging to those agreements
      */
     const std::list<AgreementKey>& GetSendBarIfDataQueuedList() const;
@@ -416,47 +485,162 @@
      * Add the given (recipient, TID) pair to the list of BA agreements for which a BAR
      * shall only be sent if there are queued data frames belonging to those agreements
      *
-     * \param recipient the recipient
-     * \param tid the TID
+     * @param recipient the recipient
+     * @param tid the TID
      */
     void AddToSendBarIfDataQueuedList(const Mac48Address& recipient, uint8_t tid);
     /**
      * Remove the given (recipient, TID) pair from the list of BA agreements for which a BAR
      * shall only be sent if there are queued data frames belonging to those agreements
      *
-     * \param recipient the recipient
-     * \param tid the TID
+     * @param recipient the recipient
+     * @param tid the TID
      */
     void RemoveFromSendBarIfDataQueuedList(const Mac48Address& recipient, uint8_t tid);
 
+    /**
+     * This function returns the minimum buffer size from ADDBA Response frames sent by all members
+     * of a group address <i>groupAddress</i> for a given TID <i>tid</i>.
+     *
+     * @param groupAddress the group address
+     * @param tid the traffic ID.
+     *
+     * @return the GCR buffer size.
+     */
+    uint16_t GetGcrBufferSize(const Mac48Address& groupAddress, uint8_t tid) const;
+
+    /**
+     * This function returns the starting sequence number of the transmit window for a given GCR
+     * Block Ack agreement established with all members of a group address <i>groupAddress</i> for a
+     * given TID <i>tid</i>.
+     *
+     * @param groupAddress the group address
+     * @param tid Traffic ID
+     *
+     * @returns the starting sequence number of the transmit window (WinStartO)
+     */
+    uint16_t GetGcrStartingSequence(const Mac48Address& groupAddress, uint8_t tid) const;
+
+    /**
+     * Check if a GCR Block Ack agreement has been successfully established with all members of
+     * the group.
+     *
+     * @param gcrGroupAddress the GCR Group Address.
+     * @param tid the traffic ID.
+     * @param members members of the group.
+     * @return true if a GCR Block Ack agreement has been successfully established with all members
+     * of the group, false otherwise.
+     */
+    bool IsGcrAgreementEstablished(const Mac48Address& gcrGroupAddress,
+                                   uint8_t tid,
+                                   const GcrManager::GcrMembers& members) const;
+
+    /**
+     * Notify the block ack manager about the last groupcast MPDU transmitted with the GCR-UR
+     * service. If there is an established block ack agreement, it makes the transmit window
+     * advance beyond the transmitted MPDU.
+     *
+     * @param mpdu the groupcast MPDU
+     * @param recipients the list of recipients for the groupcast MPDU
+     */
+    void NotifyLastGcrUrTx(Ptr<const WifiMpdu> mpdu, const GcrManager::GcrMembers& recipients);
+
   protected:
     void DoDispose() override;
 
   private:
     /**
-     * Inactivity timeout function
-     * \param recipient the recipient MAC address
-     * \param tid Traffic ID
+     * Inactivity timeout function for a Block Ack agreement
+     * @param recipient the recipient MAC address
+     * @param tid Traffic ID
+     * @param gcrGroupAddr the GCR Group Address (only if it a GCR Block Ack agreement)
      */
-    void InactivityTimeout(const Mac48Address& recipient, uint8_t tid);
+    void InactivityTimeout(const Mac48Address& recipient,
+                           uint8_t tid,
+                           std::optional<Mac48Address> gcrGroupAddr);
+
+    /**
+     * @param mpdu MPDU to store.
+     * @param recipient intended recipient for the stored MPDU.
+     * @param gcrGroupAddr the GCR Group Address (only if MPDU is transmitted using the GCR service)
+     *
+     * Stores <i>mpdu</i> for a possible future retransmission.
+     */
+    void DoStorePacket(Ptr<WifiMpdu> mpdu,
+                       const Mac48Address& recipient,
+                       std::optional<Mac48Address> gcrGroupAddr = std::nullopt);
 
     /**
      * typedef for a list of WifiMpdu.
      */
-    typedef std::list<Ptr<WifiMpdu>> PacketQueue;
+    using PacketQueue = std::list<Ptr<WifiMpdu>>;
     /**
      * typedef for an iterator for PacketQueue.
      */
-    typedef std::list<Ptr<WifiMpdu>>::iterator PacketQueueI;
+    using PacketQueueI = std::list<Ptr<WifiMpdu>>::iterator;
 
     /// AgreementKey-indexed map of originator block ack agreements
     using OriginatorAgreements =
-        std::map<AgreementKey, std::pair<OriginatorBlockAckAgreement, PacketQueue>>;
-    /// typedef for an iterator for Agreements
+        std::multimap<AgreementKey, std::pair<OriginatorBlockAckAgreement, PacketQueue>>;
+    /// An iterator for originator block ack agreements
     using OriginatorAgreementsI = OriginatorAgreements::iterator;
+    /// A const iterator for originator block ack agreements
+    using OriginatorAgreementsCI = OriginatorAgreements::const_iterator;
 
     /// AgreementKey-indexed map of recipient block ack agreements
-    using RecipientAgreements = std::map<AgreementKey, RecipientBlockAckAgreement>;
+    using RecipientAgreements = std::multimap<AgreementKey, RecipientBlockAckAgreement>;
+    /// An iterator for recipient block ack agreements
+    using RecipientAgreementsI = RecipientAgreements::iterator;
+    /// A const iterator for recipient block ack agreements
+    using RecipientAgreementsCI = RecipientAgreements::const_iterator;
+
+    /**
+     * @param recipient MAC address of the recipient
+     * @param tid Traffic ID
+     * @param gcrGroupAddr the GCR Group Address (only if it is a GCR Block Ack agreement)
+     *
+     * @return an iterator to the block ack agreement
+     */
+    OriginatorAgreementsI GetOriginatorBaAgreement(
+        const Mac48Address& recipient,
+        uint8_t tid,
+        std::optional<Mac48Address> gcrGroupAddr = std::nullopt);
+
+    /**
+     * @param recipient MAC address of the recipient
+     * @param tid Traffic ID
+     * @param gcrGroupAddr the GCR Group Address (only if it is a GCR Block Ack agreement)
+     *
+     * @return a const iterator to the block ack agreement
+     */
+    OriginatorAgreementsCI GetOriginatorBaAgreement(
+        const Mac48Address& recipient,
+        uint8_t tid,
+        std::optional<Mac48Address> gcrGroupAddr = std::nullopt) const;
+
+    /**
+     * @param originator MAC address of the originator
+     * @param tid Traffic ID
+     * @param gcrGroupAddr the GCR Group Address (only if it is a GCR Block Ack agreement)
+     *
+     * @return an iterator to the block ack agreement
+     */
+    RecipientAgreementsI GetRecipientBaAgreement(
+        const Mac48Address& originator,
+        uint8_t tid,
+        std::optional<Mac48Address> gcrGroupAddr = std::nullopt);
+
+    /**
+     * @param originator MAC address of the originator
+     * @param tid Traffic ID
+     * @param gcrGroupAddr the GCR Group Address (only if it is a GCR Block Ack agreement)
+     *
+     * @return a const iterator to the block ack agreement
+     */
+    RecipientAgreementsCI GetRecipientBaAgreement(
+        const Mac48Address& originator,
+        uint8_t tid,
+        std::optional<Mac48Address> gcrGroupAddr = std::nullopt) const;
 
     /**
      * Handle the given in flight MPDU based on its given status. If the status is
